package de.mzte.tcdumper.commands;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.List;
import java.util.Map.Entry;

import de.mzte.tcdumper.TcDumperBaseCommand;
import de.mzte.tcdumper.Util;
import net.minecraft.client.Minecraft;
import net.minecraft.command.ICommandSender;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ChatComponentText;
import thaumcraft.api.ThaumcraftApi;
import thaumcraft.api.aspects.AspectList;

public class CommandDumpItemAspects extends TcDumperBaseCommand {
    public static final String FILE_NAME = "tcitemaspects.txt";

    @Override
    public String getCommandBaseName() {
        return "itemaspects";
    }

    @Override
    public void processCommand(ICommandSender sender, String[] args) {
        try (
            OutputStream out = new BufferedOutputStream(Files.newOutputStream(
                Paths.get(
                    Minecraft.getMinecraft().mcDataDir.getAbsolutePath(), FILE_NAME
                ),
                StandardOpenOption.CREATE
            ))
        ) {
            for (Entry<List, AspectList> e : ThaumcraftApi.objectTags.entrySet()) {
                Item item = (Item) e.getKey().get(0);
                int meta = (int) e.getKey().get(1);

                out.write(("'" + new ItemStack(item, 1, meta).getDisplayName()
                           + "' = " + Util.aspectListToString(e.getValue()) + "\n")
                              .getBytes());
            }

            sender.addChatMessage(new ChatComponentText("wrote dump to " + FILE_NAME));
        } catch (IOException e1) {
            e1.printStackTrace();
        }
    }
}
