package de.mzte.tcdumper.commands;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.Map.Entry;

import de.mzte.tcdumper.TcDumperBaseCommand;
import de.mzte.tcdumper.Util;
import net.minecraft.client.Minecraft;
import net.minecraft.command.ICommandSender;
import net.minecraft.util.ChatComponentText;
import thaumcraft.api.research.ResearchCategories;
import thaumcraft.api.research.ResearchCategoryList;
import thaumcraft.api.research.ResearchItem;

public class CommandDumpResearches extends TcDumperBaseCommand {
    public static final String FILE_NAME = "tcresearches.txt";

    @Override
    public String getCommandBaseName() {
        return "researches";
    }

    @Override
    public void processCommand(ICommandSender sender, String[] args) {
        try (
            OutputStream out = new BufferedOutputStream(Files.newOutputStream(
                Paths.get(
                    Minecraft.getMinecraft().mcDataDir.getAbsolutePath(), FILE_NAME
                ),
                StandardOpenOption.CREATE
            ))
        ) {
            for (ResearchCategoryList rcl :
                 ResearchCategories.researchCategories.values()) {
                for (Entry<String, ResearchItem> e : rcl.research.entrySet()) {
                    out.write((e.getKey() + " = "
                               + Util.aspectListToString(e.getValue().tags) + "\n")
                                  .getBytes());
                }
            }

            sender.addChatMessage(new ChatComponentText("wrote dump to " + FILE_NAME));
        } catch (IOException e1) {
            e1.printStackTrace();
        }
    }
}
